// this is the code that processes server requests

import java.io.*;
import java.net.*;
import java.lang.*;

public class MTServerStuff extends Thread {

    static char eofchars[] = { (char)4, '\n' };
    static String eof = new String(eofchars);
    BufferedReader is;    // intput stream
    OutputStream os;      // output stream

    // process the data on the given socket (we see it as a stream here)

    public MTServerStuff(BufferedReader in, OutputStream out) {
        is = in;
        os = out;
    }

    public void run() {
        try {
            byte[] outbytes;

            while (true) {
                String cmd = is.readLine();    // get a line of input from the client
                if (cmd == null)
                    return;    // nothing more to read on this socket

                System.out.println("got command \"" + cmd + "\"");

                // now process the command and write the result back to the
                // client.
                if (cmd.equals("id")) {
                    outbytes = ("I'm the server\nMy name is Fred\n" + eof).getBytes();
                    os.write(outbytes, 0, outbytes.length);
                }
                else if (cmd.equals("sleep")) {
                    try {
                        sleep(5000);
                        outbytes = ("I'm awake now\n" + eof).getBytes();
                        os.write(outbytes, 0, outbytes.length);
                    }
                    catch (Exception e) {
                        e.printStackTrace();
                    }
                }
                else if (cmd.equals("who")) {
                    who_cmd(os);
                }
                else if (cmd.equals("hello")) {
                    outbytes = ("Hi there.\n" + eof).getBytes();
                    os.write(outbytes, 0, outbytes.length);
                }
		else if (cmd.equals("help")) {
                    outbytes = ("valid commands are: id who hello help sleep\n"
                                + eof).getBytes();
                    os.write(outbytes, 0, outbytes.length);
		}
                else {
                    outbytes = ("unimplemented command\n"+eof).getBytes();
                    os.write(outbytes, 0, outbytes.length);
                }
            }
        } catch (java.io.IOException e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }

    // do the "who" command
    protected void who_cmd(OutputStream os) {
        // run the who command and send the results to os
        byte[] outbytes;
        Process who = null;
        try {
            // run the Unix who command
            who = Runtime.getRuntime().exec("/usr/bin/who");
            InputStream is = who.getInputStream();
            final int bufsize = 4096;
            byte buf[] = new byte[bufsize];
            int nbytes;

            // read the results a buffer at a time (it would be
            // dumb to read line at a time unless we had some
            // need to count or deal with lines).

            while ((nbytes=is.read(buf)) != -1)
                os.write(buf, 0, nbytes);
            // write the end of output marker
            outbytes = eof.getBytes();
            os.write(outbytes, 0, outbytes.length);
            who.waitFor();
        }
        catch (Exception e) {
            try {
                outbytes = e.getMessage().getBytes();
                os.write(outbytes, 0, outbytes.length);
                outbytes = eof.getBytes();
                os.write(outbytes, 0, outbytes.length);
            }
            catch (Exception ex) {
                ex.printStackTrace();    // write failed, what can we do?
            }
        }
    }
}
