// this is the thread does the echo operations on behalf of a client connection

import java.io.*;
import java.net.*;
import java.lang.*;

public class EchoMT extends Thread {

    Socket sock;
    int threadID;
    BufferedReader in;    // input stream
    PrintStream out;      // output stream

    public EchoMT(Socket s, int id) {
        sock = s;
        threadID = id;
        try {
            in = new BufferedReader(new InputStreamReader(s.getInputStream()));
            out = new PrintStream(s.getOutputStream());
        } catch (java.io.IOException e) {
            System.err.println(e.getMessage());
        }
    }

    public void run() {
        try {
            String line;
            while ((line =in.readLine()) != null) {
                System.out.println("thread " + threadID + ": \"" + line + "\"");
                // allow a "." to terminate this session
                if (line.equals("."))
                    break;
                out.println(line);
            }
            sock.close();
        } catch (java.io.IOException e) {
            System.err.println(e.getMessage());
        }
        System.out.println("thread " + threadID + ": exiting");
    }
}
